#include <windows.h>
#include <stdio.h>

#define BUFFERSIZE 4096

unsigned char DataBuffer[BUFFERSIZE]; // ڵĻ


int main(int argc, char* argv[])
{
	if (3 != argc)
	{
		printf("usage: pe2bin.exe exeFilePath binFilePath\n");
		return 1;
	}

	//
	//  PE ļ
	//
	FILE* pExeFile = fopen(argv[1], "rb");    // ˴ԶƵķʽ򿪣
	if(NULL == pExeFile)
	{
		printf("Open exe file \"%s\" failed.\n", argv[1]);
		return 1;
	}
	
	//
	// ȡ DOS_HEADER
	//
	IMAGE_DOS_HEADER dosHeader;
	fread(&dosHeader, sizeof(dosHeader), 1, pExeFile);

	//
	// ȡ NT_HEADER
	//
	IMAGE_NT_HEADERS ntHeader;
	fseek(pExeFile, dosHeader.e_lfanew, SEEK_SET);
	fread(&ntHeader, sizeof(ntHeader), 1, pExeFile);
	if (IMAGE_NT_SIGNATURE != ntHeader.Signature)
	{
		printf("File \"%s\" is not a PE file.\n", argv[1]);
		fclose(pExeFile);
		return 1;
	}

	unsigned short numSections = ntHeader.FileHeader.NumberOfSections;
	if (0 != ntHeader.FileHeader.NumberOfSymbols 
		&&  0 != ntHeader.FileHeader.PointerToSymbolTable)
	{
		//
		// еû strip 
		//
		printf("Exe file \"%s\" still has debug section.\n", argv[1]); 
		fclose(pExeFile);
		return 1;
	}

	//
	// ȡ SECTION_TABLE
	//
	PIMAGE_SECTION_HEADER pSectionTable = (PIMAGE_SECTION_HEADER)malloc(sizeof(IMAGE_SECTION_HEADER) * numSections);
	fseek(pExeFile, sizeof(ntHeader) + dosHeader.e_lfanew, SEEK_SET);
	fread(pSectionTable, sizeof(IMAGE_SECTION_HEADER), numSections, pExeFile);

	// ַܴС(ҲнڵܴС)
	int virSize = 0;  
	for (int i = 0; i<numSections; i++)
		virSize += pSectionTable[i].Misc.VirtualSize;

	//
	//  bin ļ
	//
	FILE *pBinFile = fopen(argv[2], "wb");  
	if (NULL == pBinFile)
	{
		printf("Creating bin file \"%s\" failed.\n" ,argv[2]);
		free(pSectionTable);
		fclose(pExeFile);
		return 1;
	}

	//  bin ļĴСΪ virSizeͬʱ 0 
	unsigned char c = 0; 
	for (int i = 0; i < virSize; i++)
		fwrite(&c, sizeof(unsigned char), 1, pBinFile);

	for (int i = 0; i<numSections; i++)
	{
		int RawOffset    = pSectionTable[i].PointerToRawData;      //  PE ļеƫֵ
		int virAddress   = pSectionTable[i].VirtualAddress;	  	   // ӳ䵽ڴеַ
		int sizeOfSection= pSectionTable[i].SizeOfRawData;		   // ڵĴС

		if (0 == sizeOfSection || 0 == strcmp((char*)pSectionTable[i].Name, ".idata"))
			continue;

		printf("    Section Name: %s\n",   pSectionTable[i].Name);
		printf("  VirtualAddress: %08x\n", pSectionTable[i].VirtualAddress);
		printf("   SizeOfRawData: %08x\n", pSectionTable[i].SizeOfRawData);
		printf("PointerToRawData: %08x\n", pSectionTable[i].PointerToRawData);
		printf("*********************************************************\n");

		fseek(pExeFile, RawOffset, SEEK_SET);
		fseek(pBinFile, virAddress, SEEK_SET);	

		//  argv[1] ݣͬʱд argv[2]
		for(; sizeOfSection > 0; )
		{
			int nSize = sizeOfSection >= BUFFERSIZE ? BUFFERSIZE : sizeOfSection;

			fread(DataBuffer,  sizeof(unsigned char), nSize, pExeFile);			
			fwrite(DataBuffer, sizeof(unsigned char), nSize, pBinFile);

			sizeOfSection -= BUFFERSIZE;
		}
	}

	free(pSectionTable);

	fclose(pExeFile);
	fclose(pBinFile);

	return 0;
}
